
--recordes your bag and inventory data
function YGS_BAG_PARSE()
	YssGuildShop.db.char.YGSBAG={}
	for b=0,4 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop:Print(GetContainerItemLink(b,s)) -- debugline
				local _, itemCount = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YssGuildShop.db.char.YGSBAG[itemID] ~= nil then
					YssGuildShop.db.char.YGSBAG[itemID] = YssGuildShop.db.char.YGSBAG[itemID] + itemCount
				else
					YssGuildShop.db.char.YGSBAG[itemID] = itemCount
				end
			end
		end
	end
	for inv=1,19 do
		if (GetInventoryItemLink("player",inv)) then
			--YssGuildShop:Print(GetContainerItemLink(b,s)) -- debugline
			local itemCount = GetInventoryItemCount("player",inv)
			local itemID = YssGuildShop_itemID_c(GetInventoryItemLink("player",inv))
			if YssGuildShop.db.char.YGSBAG[itemID] ~= nil then
				YssGuildShop.db.char.YGSBAG[itemID] = YssGuildShop.db.char.YGSBAG[itemID] + itemCount
			else
				YssGuildShop.db.char.YGSBAG[itemID] = itemCount
			end
		end
	end
	if YssGuildShop.db.char.YGSBANK ~= nil and YssGuildShop.db.char.YGSBAG ~= nil then
		--YssGuildShop:Print("Merge Scheduled") -- debugline
		YGS_BANK_BAG_MERGE()
	end
end

-- records your bank data
function YGS_BANK_PARSE()
	YssGuildShop.db.char.YGSBANK = {}
	local uniquecheck = 0
	local b = BANK_CONTAINER
        for s=1,GetContainerNumSlots(b) do 
		if (GetContainerItemLink(b,s)) then
			local _, itemCount = GetContainerItemInfo(b,s)
			local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
			if YssGuildShop.db.char.YGSBANK[itemID] ~= nil then
				YssGuildShop.db.char.YGSBANK[itemID] = YssGuildShop.db.char.YGSBANK[itemID] + itemCount
			else
				YssGuildShop.db.char.YGSBANK[itemID] = itemCount
			end
		end
        end
        for b=5,11 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local _, itemCount = GetContainerItemInfo(b,s)
				local itemID = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YssGuildShop.db.char.YGSBANK[itemID] ~= nil then
					YssGuildShop.db.char.YGSBANK[itemID] = YssGuildShop.db.char.YGSBANK[itemID] + itemCount
				else
					YssGuildShop.db.char.YGSBANK[itemID] = itemCount
				end
			end
		end
        end
end

-- merges bank/bag/inventory data
function YGS_BANK_BAG_MERGE()
	--YssGuildShop:Print("Merging.......") -- debugline
	local YGS_LOCAL_DB = {}
	local uniquecheck = 0
	if YssGuildShop.db.char.YGSBAG ~= nil then
		if YssGuildShop.db.char.YGSBANK ~= nil then
			for itemID, value in pairs(YssGuildShop.db.char.YGSBANK) do
				YssGuildShop_share_value(itemID)
				YGS_LOCAL_DB[itemID] = rawget(YssGuildShop.db.char.YGSBANK, itemID)
				YssGuildShop_item_db(itemID)
			end
			for itemID, value in pairs(YssGuildShop.db.char.YGSBAG) do
				YssGuildShop_share_value(itemID)
				if YGS_LOCAL_DB[itemID] ~= nil then
					YGS_LOCAL_DB[itemID] = "[" .. value .. "/" .. YGS_LOCAL_DB[itemID] .. "/" .. (YGS_LOCAL_DB[itemID] + value) .. "]"
				else
					YssGuildShop_item_db(itemID)
					YGS_LOCAL_DB[itemID] =  "["..YssGuildShop.db.char.YGSBAG[itemID].."/0/"..YssGuildShop.db.char.YGSBAG[itemID].."]"
				end
			end
			for itemID, value in pairs(YGS_LOCAL_DB) do
				--YssGuildShop:Print(value[2])
				if string.gsub (value, "%[.*%]", "true") ~= "true" then
					--YssGuildShop:Print("Fixed: "..key)
					YGS_LOCAL_DB[itemID] = "[0/"..value.."/"..value.."]"
				end
			end
		end
	end
	table.sort(YGS_LOCAL_DB)
	uniquecheck = 0
	YGS_LOCAL_DB["YGS_ID"] = YssGuildShop:YGS_ID()
	if YssGuildShop.db.account.YGSDB ~= nil and YssGuildShop.db.account.YGSDB ~= {} then
		for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
			if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == YGS_LOCAL_DB["YGS_ID"][1] and YssGuildShop.db.account.YGSDB[k]["YGS_ID"][4] == YGS_LOCAL_DB["YGS_ID"][4] then
				YssGuildShop.db.account.YGSDB[k] = YGS_LOCAL_DB
				uniquecheck = 1
			end
		end
		if uniquecheck == 0 then
			YssGuildShop.db.account.YGSDB[table.maxn(YssGuildShop.db.account.YGSDB)+1] = YGS_LOCAL_DB
		end
	else
		YssGuildShop.db.account.YGSDB = {}
		YssGuildShop.db.account.YGSDB[1] = YGS_LOCAL_DB
	end
	YssGuildShop:Send()
end

--adds items to YssGuildShop.db.char.YGS_share filter and YssGuildShop.db.char.YGS_value
function YssGuildShop_share_value(itemID, value, timestamp)
	if YssGuildShop.db.char.YGS_value[itemID] == nil then
		if value ~= nil then
			YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
		else
			YssGuildShop.db.char.YGS_value[itemID] = {}
			YssGuildShop.db.char.YGS_value[itemID][1] = "no value set"
		end
	else
		if YssGuildShop.db.char.YGS_value[itemID][1] == "no value set" then
			if value ~= nil then
				YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
			else
				YssGuildShop.db.char.YGS_value[itemID] = {}
				YssGuildShop.db.char.YGS_value[itemID][1] = "no value set"
			end
		elseif timestamp then
			if YssGuildShop.db.char.YGS_value[itemID][2] < timestamp then
				YssGuildShop.db.char.YGS_value[itemID] = {value, timestamp}
			end
		end
	end
	if YssGuildShop.db.char.YGS_share_filter[itemID] == nil then
		YssGuildShop.db.char.YGS_share_filter[itemID] = rawget(YssGuildShop.db.char.YGS_settings ,2)
	end
end

function YssGuildShop_share_set(bvalue)
	for itemID, value in pairs(YssGuildShop.db.char.YGS_share_filter) do
		YssGuildShop.db.char.YGS_share_filter[itemID] = bvalue
	end
	YGS_Filter_ScrollBar_Update()
end

--itemID compression decompression and retrival functions
function YssGuildShop_itemID_c(link)
	if not link then return end
	local _, _, itemID = string.find(link, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)")
	return itemID
end

function YssGuildShop_itemID_d(item)
	if( not item ) then return nil end
	local itemName = GetItemInfo(item) 
	return itemName
end

function YssGuildShop_itemID_L(item)
	if( not item ) then return nil end
	local _, itemLink = GetItemInfo(item) 
	return itemLink
end

function YssGuildShop_item_db(itemID)
	if YssGuildShop.db.char.YGS_value[itemID] == nil then
		YssGuildShop.db.char.YGS_value[itemID] = {false,""}
	end
end
